% detectionTask
% Wallish 3.4 p 92-
% variations p95
% figure must be selected for keyboard input to count!
% "." for present, "," for absent
% currently written to run 200 trials, 20 each of ten intensities including
% zero
% mcw 3-17-17

format compact
clear all
close all

temp = uint8(zeros(400,400,3)); % create a dark stimulus matrix
temp1 = cell(10,1); % create a cell array that can hold 10 matrices
                    % each one is an image with a fixation point and a test
                    % point of varying brightnesses including 0

for i=1:10 % filling temp1
    temp(200:201,200:201,:) = 255; % inserting a fixation point: 255 is brightest light level for all 3 color guns at pixel(200,200)=(row down,column to right)
    temp(200:201,240:241,:) = (i-1)*10; % insterting a test point 40 pixels right of it.
    % brightness range 0 to 90.
    temp1{i} = temp; % putting the respective modified matrix in cell
end % done filling temp1

h = figure; % creating figure with handle h

stimulusorder = randperm(200); % creating a random order from 1 to 200 for the 200 trials.
% allows to have equal number per condition
stimulusorder = mod(stimulusorder,10); % using the modulus function to create a range
% from 0 to 9.  20 each.
stimulusorder = stimulusorder + 1; % now the range is from 1 to 10 as desired

score = zeros(10,1); % keeping score: how many stimuli were reported seen
                        % at each brightness level

for i=1:200 % 200 trials, 20 per condition
    image(temp1{stimulusorder(1,i)})  % image the respective matrix as designated by stimulusorder
    disp(['trial number ' num2str(i)]) % give subject feedback about which trial we are in; no other feedback
    pause; % get the keypress
    temp2 = get(h,'CurrentCharacter'); % get the keypress.  "." for present, "," for absent
                        % mcw: ONLY WORKS IF FIGURE IS SELECTED, 
                        % NOT WORKSPACE
    temp3 = strcmp('.',temp2); % compare strings.  If . (present), temp3 = 1; otherwise 0.
    score(stimulusorder(1,i)) = score(stimulusorder(1,i)) + temp3; % add up in the respective score sheet.
end % trial presentation ends after 200 trials

figure(2)
plot(score)
xlabel('Brightness (max 255)')
ylabel('Number detected (out of 20)')
